package ch.epfl.ppo.gui;

import java.awt.BorderLayout;
import java.awt.image.BufferedImage;
import java.net.URL;

import javax.imageio.ImageIO;
import javax.swing.JFrame;

import ch.epfl.ppo.ColorRGB;
import ch.epfl.ppo.ImageRGB;
import ch.epfl.ppo.adapters.DiscreteImageAdapter;

public final class ImageViewer {
    public static void main(String[] args) {
        javax.swing.SwingUtilities.invokeLater(new Runnable() {
            @Override
            public void run() {
                try {
                    // L'image à afficher, à modifier au fur et à mesure de
                    // votre avancement.
                    URL imageURL = new URL("http://cs108.epfl.ch/images/dubrovnik.jpg");
                    BufferedImage discreteImage = ImageIO.read(imageURL);
                    ImageRGB image = new DiscreteImageAdapter(ColorRGB.BLACK, discreteImage);

                    JFrame mainWindow = new JFrame("Image viewer");
                    mainWindow.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);

                    mainWindow.getContentPane().setLayout(new BorderLayout());
                    ImageComponent imageComponent = new ImageComponent(image, 0, 0, 4);
                    mainWindow.getContentPane().add(imageComponent, BorderLayout.CENTER);

                    mainWindow.pack();
                    mainWindow.setVisible(true);
                } catch (Exception e) {
                    e.printStackTrace();
                }
            }
        });
    }
}
