package ch.epfl.ppo.transformers;

import ch.epfl.ppo.ColorRGB;
import ch.epfl.ppo.ImageRGB;

public final class RotationTransformer implements ImageRGB {
    private final ImageRGB imageToRotate;
    private final double angle;

    public RotationTransformer(ImageRGB imageToRotate, double angle) {
        this.imageToRotate = imageToRotate;
        this.angle = angle;
    }

    @Override
    public ColorRGB valueAt(double x, double y) {
        double rX = x * Math.cos(-angle) - y * Math.sin(-angle);
        double rY = x * Math.sin(-angle) + y * Math.cos(-angle);
        return imageToRotate.valueAt(rX, rY);
    }
}
